/*
 File: subrule_defsym.cpp
 Date and Time: Fri Jan 30 18:55:24 2015 
*/
#include "subrule_def.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_subrule_def;// grammar's ns
// first set terminals
yacco2::THR _YACCO2_CALL_TYPE
NS_subrule_def::TH_subrule_def(yacco2::Parser* Caller_pp){
  yacco2::Thread_entry& pp_thread_entry = ITH_subrule_def;
  NS_subrule_def::Csubrule_def Csubrule_def_;// parallel-parser's parse table
#define ssPARSE_TABLE Csubrule_def_
#include "wpp_core.h"
}
THR_result _YACCO2_CALL_TYPE
NS_subrule_def::PROC_TH_subrule_def(yacco2::Parser* Caller_pp){
  char called_proc_name[] = "PROC_TH_subrule_def";
  static bool one_time(false);
  static NS_subrule_def::Csubrule_def* NS_subrule_def_Csubrule_def_(0);// parallel-parser's fsm table
  static Parser* NS_subrule_def_Csubrule_def_parser(0);
  Parser* proc_parser(0);
  if(one_time == false){
    one_time = true;
    NS_subrule_def_Csubrule_def_ = new NS_subrule_def::Csubrule_def();// parallel-parser's fsm table
    NS_subrule_def_Csubrule_def_parser = new Parser(*NS_subrule_def_Csubrule_def_,Caller_pp);
  }
 proc_parser = NS_subrule_def_Csubrule_def_parser;
#include "wproc_pp_core.h"
}
void 
Csubrule_def::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Rsubrule_def_:{
       Rsubrule_def* sym;
     if(re->rule_ == 0){
       sym = new Rsubrule_def(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsubrule_def*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 4;
    

     sym->sr1();
     return;}
    case rhs1_Rvector_:{
       Rvector* sym;
     if(re->rule_ == 0){
       sym = new Rvector(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rvector*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Rcommon_comments_:{
       Rcommon_comments* sym;
     if(re->rule_ == 0){
       sym = new Rcommon_comments(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rcommon_comments*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     return;}
    case rhs1_Rrhs_expr_:{
       Rrhs_expr* sym;
     if(re->rule_ == 0){
       sym = new Rrhs_expr(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrhs_expr*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 5;
    

     return;}
    case rhs2_Rrhs_expr_:{
       Rrhs_expr* sym;
     if(re->rule_ == 0){
       sym = new Rrhs_expr(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrhs_expr*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 9;
    

     return;}
    case rhs3_Rrhs_expr_:{
       Rrhs_expr* sym;
     if(re->rule_ == 0){
       sym = new Rrhs_expr(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrhs_expr*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 11;
    

     return;}
    case rhs4_Rrhs_expr_:{
       Rrhs_expr* sym;
     if(re->rule_ == 0){
       sym = new Rrhs_expr(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrhs_expr*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 9;
    

     return;}
    case rhs5_Rrhs_expr_:{
       Rrhs_expr* sym;
     if(re->rule_ == 0){
       sym = new Rrhs_expr(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrhs_expr*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 11;
    

     return;}
    case rhs1_Rstart_thread_:{
       Rstart_thread* sym;
     if(re->rule_ == 0){
       sym = new Rstart_thread(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rstart_thread*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs1_Rbal_thread_expr_:{
       Rbal_thread_expr* sym;
     if(re->rule_ == 0){
       sym = new Rbal_thread_expr(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rbal_thread_expr*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     return;}
    case rhs1_Rrtned_T_:{
       Rrtned_T* sym;
     if(re->rule_ == 0){
       sym = new Rrtned_T(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrtned_T*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rrtned_T_:{
       Rrtned_T* sym;
     if(re->rule_ == 0){
       sym = new Rrtned_T(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrtned_T*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rrtned_T_:{
       Rrtned_T* sym;
     if(re->rule_ == 0){
       sym = new Rrtned_T(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrtned_T*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr3();
     return;}
    case rhs4_Rrtned_T_:{
       Rrtned_T* sym;
     if(re->rule_ == 0){
       sym = new Rrtned_T(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrtned_T*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr4();
     return;}
    case rhs1_Rcalled_thread_:{
       Rcalled_thread* sym;
     if(re->rule_ == 0){
       sym = new Rcalled_thread(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rcalled_thread*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     sym->sr1();
     return;}
    case rhs2_Rcalled_thread_:{
       Rcalled_thread* sym;
     if(re->rule_ == 0){
       sym = new Rcalled_thread(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rcalled_thread*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_RNULL_:{
       RNULL* sym;
     if(re->rule_ == 0){
       sym = new RNULL(parser__);
       re->rule_ = sym;
     }else{
       sym = (RNULL*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs1_Rns_:{
       Rns* sym;
     if(re->rule_ == 0){
       sym = new Rns(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rns*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rns_:{
       Rns* sym;
     if(re->rule_ == 0){
       sym = new Rns(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rns*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rns_:{
       Rns* sym;
     if(re->rule_ == 0){
       sym = new Rns(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rns*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr3();
     return;}
    case rhs1_Rdbl_colon_:{
       Rdbl_colon* sym;
     if(re->rule_ == 0){
       sym = new Rdbl_colon(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdbl_colon*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rdbl_colon_:{
       Rdbl_colon* sym;
     if(re->rule_ == 0){
       sym = new Rdbl_colon(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdbl_colon*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rdbl_colon_:{
       Rdbl_colon* sym;
     if(re->rule_ == 0){
       sym = new Rdbl_colon(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdbl_colon*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr3();
     return;}
    case rhs1_Rth_name_:{
       Rth_name* sym;
     if(re->rule_ == 0){
       sym = new Rth_name(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rth_name*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rth_name_:{
       Rth_name* sym;
     if(re->rule_ == 0){
       sym = new Rth_name(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rth_name*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rth_name_:{
       Rth_name* sym;
     if(re->rule_ == 0){
       sym = new Rth_name(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rth_name*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr3();
     return;}
    case rhs1_Rcalled_proc_op_:{
       Rcalled_proc_op* sym;
     if(re->rule_ == 0){
       sym = new Rcalled_proc_op(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rcalled_proc_op*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs1_Rbal_called_proc_expr_:{
       Rbal_called_proc_expr* sym;
     if(re->rule_ == 0){
       sym = new Rbal_called_proc_expr(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rbal_called_proc_expr*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     return;}
    case rhs1_Rcalled_proc_name_:{
       Rcalled_proc_name* sym;
     if(re->rule_ == 0){
       sym = new Rcalled_proc_name(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rcalled_proc_name*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     sym->sr1();
     return;}
    case rhs2_Rcalled_proc_name_:{
       Rcalled_proc_name* sym;
     if(re->rule_ == 0){
       sym = new Rcalled_proc_name(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rcalled_proc_name*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_RTorRcomponents_epi_:{
       RTorRcomponents_epi* sym;
     if(re->rule_ == 0){
       sym = new RTorRcomponents_epi(parser__);
       re->rule_ = sym;
     }else{
       sym = (RTorRcomponents_epi*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    case rhs2_RTorRcomponents_epi_:{
       RTorRcomponents_epi* sym;
     if(re->rule_ == 0){
       sym = new RTorRcomponents_epi(parser__);
       re->rule_ = sym;
     }else{
       sym = (RTorRcomponents_epi*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_RTorRcomponents_:{
       RTorRcomponents* sym;
     if(re->rule_ == 0){
       sym = new RTorRcomponents(parser__);
       re->rule_ = sym;
     }else{
       sym = (RTorRcomponents*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs2_RTorRcomponents_:{
       RTorRcomponents* sym;
     if(re->rule_ == 0){
       sym = new RTorRcomponents(parser__);
       re->rule_ = sym;
     }else{
       sym = (RTorRcomponents*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     return;}
    case rhs1_RTorRcomponent_:{
       RTorRcomponent* sym;
     if(re->rule_ == 0){
       sym = new RTorRcomponent(parser__);
       re->rule_ = sym;
     }else{
       sym = (RTorRcomponent*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_RTorRcomponent_:{
       RTorRcomponent* sym;
     if(re->rule_ == 0){
       sym = new RTorRcomponent(parser__);
       re->rule_ = sym;
     }else{
       sym = (RTorRcomponent*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_RTorRcomponent_:{
       RTorRcomponent* sym;
     if(re->rule_ == 0){
       sym = new RTorRcomponent(parser__);
       re->rule_ = sym;
     }else{
       sym = (RTorRcomponent*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr3();
     return;}
    case rhs1_Rchained_dispatcher_:{
       Rchained_dispatcher* sym;
     if(re->rule_ == 0){
       sym = new Rchained_dispatcher(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rchained_dispatcher*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rchained_dispatcher_:{
       Rchained_dispatcher* sym;
     if(re->rule_ == 0){
       sym = new Rchained_dispatcher(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rchained_dispatcher*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rchained_dispatcher_:{
       Rchained_dispatcher* sym;
     if(re->rule_ == 0){
       sym = new Rchained_dispatcher(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rchained_dispatcher*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr3();
     return;}
    case rhs1_Rmust_eos_:{
       Rmust_eos* sym;
     if(re->rule_ == 0){
       sym = new Rmust_eos(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmust_eos*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rmust_eos_:{
       Rmust_eos* sym;
     if(re->rule_ == 0){
       sym = new Rmust_eos(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmust_eos*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr2();
     return;}
    case rhs3_Rmust_eos_:{
       Rmust_eos* sym;
     if(re->rule_ == 0){
       sym = new Rmust_eos(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmust_eos*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr3();
     return;}
    case rhs1_Rcalled_thd_eos_:{
       Rcalled_thd_eos* sym;
     if(re->rule_ == 0){
       sym = new Rcalled_thd_eos(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rcalled_thd_eos*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rcalled_thd_eos_:{
       Rcalled_thd_eos* sym;
     if(re->rule_ == 0){
       sym = new Rcalled_thd_eos(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rcalled_thd_eos*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr2();
     return;}
    case rhs1_Rcalled_proc_eos_:{
       Rcalled_proc_eos* sym;
     if(re->rule_ == 0){
       sym = new Rcalled_proc_eos(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rcalled_proc_eos*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rcalled_proc_eos_:{
       Rcalled_proc_eos* sym;
     if(re->rule_ == 0){
       sym = new Rcalled_proc_eos(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rcalled_proc_eos*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr2();
     return;}
    case rhs1_Rpotential_codeblk_:{
       Rpotential_codeblk* sym;
     if(re->rule_ == 0){
       sym = new Rpotential_codeblk(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rpotential_codeblk*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rpotential_directives_:{
       Rpotential_directives* sym;
     if(re->rule_ == 0){
       sym = new Rpotential_directives(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rpotential_directives*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    case rhs2_Rpotential_directives_:{
       Rpotential_directives* sym;
     if(re->rule_ == 0){
       sym = new Rpotential_directives(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rpotential_directives*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 6;
    

     return;}
    case rhs1_Rmust_directive_phrase_:{
       Rmust_directive_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rmust_directive_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmust_directive_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 5;
    

     sym->sr1();
     return;}
    case rhs1_Rmust_directive_:{
       Rmust_directive* sym;
     if(re->rule_ == 0){
       sym = new Rmust_directive(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmust_directive*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     sym->op();
     return;}
    case rhs2_Rmust_directive_:{
       Rmust_directive* sym;
     if(re->rule_ == 0){
       sym = new Rmust_directive(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmust_directive*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     sym->op();
     return;}
    case rhs3_Rmust_directive_:{
       Rmust_directive* sym;
     if(re->rule_ == 0){
       sym = new Rmust_directive(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmust_directive*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr3();
     sym->op();
     return;}
    case rhs1_Rclose_brace_:{
       Rclose_brace* sym;
     if(re->rule_ == 0){
       sym = new Rclose_brace(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rclose_brace*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs2_Rclose_brace_:{
       Rclose_brace* sym;
     if(re->rule_ == 0){
       sym = new Rclose_brace(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rclose_brace*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rmaybe_more_directives_:{
       Rmaybe_more_directives* sym;
     if(re->rule_ == 0){
       sym = new Rmaybe_more_directives(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmaybe_more_directives*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    case rhs2_Rmaybe_more_directives_:{
       Rmaybe_more_directives* sym;
     if(re->rule_ == 0){
       sym = new Rmaybe_more_directives(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmaybe_more_directives*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rmaybe_directive_phrases_:{
       Rmaybe_directive_phrases* sym;
     if(re->rule_ == 0){
       sym = new Rmaybe_directive_phrases(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmaybe_directive_phrases*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs2_Rmaybe_directive_phrases_:{
       Rmaybe_directive_phrases* sym;
     if(re->rule_ == 0){
       sym = new Rmaybe_directive_phrases(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmaybe_directive_phrases*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Rmaybe_directive_phrase_:{
       Rmaybe_directive_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rmaybe_directive_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmaybe_directive_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 5;
    

     sym->sr1();
     return;}
    case rhs2_Rmaybe_directive_phrase_:{
       Rmaybe_directive_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rmaybe_directive_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmaybe_directive_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     sym->sr2();
     return;}
    case rhs1_Rdirective_phrase_:{
       Rdirective_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rdirective_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 6;
    

     sym->sr1();
     return;}
    case rhs1_Rdirective_:{
       Rdirective* sym;
     if(re->rule_ == 0){
       sym = new Rdirective(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     sym->op();
     return;}
    case rhs2_Rdirective_:{
       Rdirective* sym;
     if(re->rule_ == 0){
       sym = new Rdirective(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     sym->op();
     return;}
    case rhs1_Rsyntax_code_:{
       Rsyntax_code* sym;
     if(re->rule_ == 0){
       sym = new Rsyntax_code(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsyntax_code*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rsyntax_code_:{
       Rsyntax_code* sym;
     if(re->rule_ == 0){
       sym = new Rsyntax_code(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsyntax_code*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs1_Rlint_epi_:{
       Rlint_epi* sym;
     if(re->rule_ == 0){
       sym = new Rlint_epi(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlint_epi*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs2_Rlint_epi_:{
       Rlint_epi* sym;
     if(re->rule_ == 0){
       sym = new Rlint_epi(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlint_epi*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rdirective_cweb_k_epi_:{
       Rdirective_cweb_k_epi* sym;
     if(re->rule_ == 0){
       sym = new Rdirective_cweb_k_epi(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective_cweb_k_epi*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    case rhs2_Rdirective_cweb_k_epi_:{
       Rdirective_cweb_k_epi* sym;
     if(re->rule_ == 0){
       sym = new Rdirective_cweb_k_epi(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective_cweb_k_epi*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rdirective_cweb_k_epi_:{
       Rdirective_cweb_k_epi* sym;
     if(re->rule_ == 0){
       sym = new Rdirective_cweb_k_epi(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective_cweb_k_epi*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr3();
     return;}
    case rhs4_Rdirective_cweb_k_epi_:{
       Rdirective_cweb_k_epi* sym;
     if(re->rule_ == 0){
       sym = new Rdirective_cweb_k_epi(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdirective_cweb_k_epi*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr4();
     return;}
    case rhs1_Rcweb_k_epi_:{
       Rcweb_k_epi* sym;
     if(re->rule_ == 0){
       sym = new Rcweb_k_epi(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rcweb_k_epi*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rcweb_k_epi_:{
       Rcweb_k_epi* sym;
     if(re->rule_ == 0){
       sym = new Rcweb_k_epi(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rcweb_k_epi*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rcweb_k_epi_:{
       Rcweb_k_epi* sym;
     if(re->rule_ == 0){
       sym = new Rcweb_k_epi(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rcweb_k_epi*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr3();
     return;}
    case rhs4_Rcweb_k_epi_:{
       Rcweb_k_epi* sym;
     if(re->rule_ == 0){
       sym = new Rcweb_k_epi(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rcweb_k_epi*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    default: return;
   }
}
